; lcsetup.nsi
;
; LogonChanger Installer
;--------------------------------
!include "MUI.nsh"
!define VERSION "v.0.1"
!define NAME "Logon Changer ${VERSION}"
!define RegKey "Software\Microsoft\Windows\CurrentVersion\Uninstall\${NAME}"

!define USERINCLUDE "Installer"
!addincludedir ${USERINCLUDE}
;!packhdr temp.dat "upx --best temp.dat"
;SetCompressor lzma
SetCompress off

XPStyle on
OutFile Setup.exe
Name "${NAME}"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\READ_ME.txt"
;!define MUI_FINISHPAGE_SHOWREADME_TEXT "$(msgShowReadMe)"

!define MUI_LANGDLL_REGISTRY_ROOT HKLM
!define MUI_LANGDLL_REGISTRY_KEY "${RegKey}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "LangDLL"
!define MUI_COMPONENTSPAGE_SMALLDESC
!define MUI_ICON "modern-install-blue-full.ico"
!define MUI_UNICON "modern-uninstall-blue-full.ico"
!define MUI_BGCOLOR "FFFFFF"
!define MUI_LICENSEPAGE_BGCOLOR /gray
!define MUI_INSTFILESPAGE_COLORS "00ff00 000000"
!define MUI_INSTFILESPAGE_PROGRESSBAR ""
!define MUI_WELCOMEFINISHPAGE_BITMAP "llama.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "llama.bmp"
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_UNFINISHPAGE_NOAUTOCLOSE
!define MUI_COMPONENTSPAGE_CHECKBITMAP "${NSISDIR}\Contrib\Graphics\Checks\colorful.bmp"

;!define MUI_UI "modern.exe"

;-------------------------------

ShowUninstDetails show
ShowInstDetails show

;-------------------------------

Var RK

!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE $(myLicenseData)

;!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_COMPONENTS
;!insertmacro MUI_PAGE_STARTMENU Application $MenuFolder
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_WELCOME
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

;--------------------------------

!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Russian"

;--------------------------------
LicenseLangString myLicenseData ${LANG_ENGLISH} "eng_lic.txt"
LicenseLangString myLicenseData ${LANG_RUSSIAN} "rus_lic.txt"
LicenseData $(myLicenseData)
;--------------------------------

InstallDir "$SYSDIR" ; ${SYSDIR}
InstallDirRegKey HKLM "${RegKey}" "Instdir"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT HKLM
;-------------------------------

!macro SetLangString StrName  EText RText
	LangString ${StrName} ${LANG_ENGLISH} "${EText}"
	LangString ${StrName} ${LANG_RUSSIAN} "${RText}"
!macroend

;-------------------------------

!insertmacro SetLangString msgReinstallText \
	"Previous installation was found.$\nWould you like to uninstall it?" \
	"Previous installation was found.$\nWould you like to uninstall it?"
;	"   .$\n ?"
!insertmacro SetLangString msgShowReadme "Show READ_ME" " READ_ME"
!insertmacro SetLangString sectionMainName "Logon Changer executables" " "
!insertmacro SetLangString sectionUISName "Logon User Interfaces" "   "
!insertmacro SetLangString tinstFull "Full" " "
;--------------------------------
InstType $(tinstFull)
;-------------------------------

!cd ".."
Section "-Install"
	SetOutPath $INSTDIR
SectionEnd
;++++++++++++++++++++++++++++++++
Section $(sectionMainName) sectionMain
	SectionIn 1 2 RO
	File "lc.exe"
   File "READ_ME.txt"
	WriteUninstaller "uninstall.exe"
	; write uninstall strings
	WriteRegStr HKLM "${RegKey}" "DisplayName" "${NAME}"
	;WriteRegStr HKLM "${RegKey}" "DisplayIcon" "$INSTDIR\chat_Client.exe"
   WriteRegStr HKLM "${RegKey}" "DisplayIcon" "$INSTDIR\modern-uninstall-blue-full.ico"
	WriteRegStr HKLM "${RegKey}" "UninstallString" '"$INSTDIR\uninstall.exe"'
	WriteRegStr HKLM "${RegKey}" "Publisher" "Artiom N."
	WriteRegStr HKLM "${RegKey}" "Readme" "$INSTDIR\READ_ME.txt"
	WriteRegDWORD HKLM "${RegKey}" "NoModify" 1
	WriteRegDWORD HKLM "${RegKey}" "NoRepair" 1
SectionEnd
;++++++++++++++++++++++++++++++++
Section $(sectionUISName) sectionUIS
   SectionIn 1
   File "logonuis\*.exe"
SectionEnd
;++++++++++++++++++++++++++++++++
Section "Uninstall"
	Delete "$INSTDIR\logonuis\*.exe"
	RMDir "$INSTDIR\logonuis"
   ExecWait "$INSTDIR\lc.exe --restore"
	Delete "$INSTDIR\lc.exe"
	RMDir "$INSTDIR"
	DeleteRegKey HKLM "${RegKey}"
SectionEnd

;--------------------------------

!cd "Installer"

!insertmacro SetLangString DESCR_SecMain "Logon Changer executable" \
			" Logon Changer"
!insertmacro SetLangString DESCR_SecUIS "User logon interfaces" \
         " "

!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
	!insertmacro MUI_DESCRIPTION_TEXT ${sectionMain} $(DESCR_SecMain)
	!insertmacro MUI_DESCRIPTION_TEXT ${sectionUIS} $(DESCR_SecUIS)
!insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
Function .onInit
	SetShellVarContext all
	!define MUI_LANGDLL_ALWAYSSHOW
	;   . 
	ReadRegStr $RK HKLM "${RegKey}" "UninstallString"
	IfErrors no_prev_insts
		MessageBox MB_YESNO|MB_ICONQUESTION "$(msgReinstallText)" IDNO no_prev_insts
		;  
		ExecWait "$RK /S"
	no_prev_insts:
	!insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd
;--------------------------------
Function un.onInit
	SetShellVarContext all
	!insertmacro MUI_UNGETLANGUAGE
;	!insertmacro MUI_STARTMENU_GETFOLDER Application $MenuFolder
FunctionEnd
;--------------------------------